#-------------------------------------------------
# variables 
#-------------------------------------------------

ORASOURCES := \
	cpp/PreDirectiveTab.ora \
	cpp/PreExprTab.ora \
	cpp/PreTokenTab.ora \
	scanner/CCommentTab.ora \
	scanner/CCoreTab.ora \
	scanner/CDirectiveTab.ora \
	scanner/CIdentifierTab.ora \
	scanner/CMLCommentTab.ora \
	scanner/CSLCommentTab.ora \
	scanner/CStringTab.ora \
	scanner/CWhitespaceTab.ora \
	scanner/CWildcardTab.ora

LEMSOURCES := \
	cpp/PreExprParser.lem \
	cpp/PreParser.lem \
	manip/CMatchParser.lem

ASPECTS := \
	aspects/WinIfExists.ah \
	aspects/WinImportHandler.ah \
	aspects/WinMacros.ah \
	aspects/CMatchSyntax.ah \
	aspects/ExtGnu.ah \
	aspects/ExtAC.ah \
	aspects/ExtACBuilderH.ah \
	aspects/ExtACBuilderCC.ah \
	aspects/ExtACSyntaxH.ah \
	aspects/ExtACSyntaxCC.ah \
	aspects/ExtACTree.ah \
	aspects/ExtACKeywords.ah \
	aspects/TraceSyntax.ah \
	aspects/WinAsm.ah \
	aspects/WinDeclSpecs.ah \
	aspects/WinMemberExplSpec.ah \
	aspects/WinTypeKeywords.ah \
	aspects/PragmaOnceUnitState.ah \
	aspects/PragmaOnce.ah \
	parser/ccparser/CCExprResolveH.ah \
	parser/ccparser/CCExprResolveCC.ah \
	parser/cparser/CExprResolveH.ah \
	parser/cparser/CExprResolveCC.ah

SOURCES := \
	aspects/ExtACTree.cc \
	cpp/ImportHandler.cc \
	cpp/PreAnswer.cc \
	cpp/PreAssertionEvaluator.cc \
	cpp/PreMacro.cc \
	cpp/PreMacroExpander.cc \
	cpp/PreMacroManager.cc \
	cpp/PreParserState.cc \
	cpp/PrePredicate.cc \
	cpp/PrePredicateManager.cc \
	cpp/PrePrintVisitor.cc \
	cpp/PreTree.cc \
	cpp/PreTreeComposite.cc \
	cpp/PreFileIncluder.cc \
	cpp/PreprocessorParser.cc \
	common/OptsParser.cc \
	common/SimpleParser.cc \
	common/Config.cc \
	common/ErrorCollector.cc \
	common/ErrorSeverity.cc \
	common/ErrorSink.cc \
	common/ErrorStream.cc \
	common/FileUnit.cc \
	common/Filename.cc \
	common/FilenameInfo.cc \
	common/LocManager.cc \
	common/Location.cc \
	common/LocationInfo.cc \
	common/PathInfo.cc \
	common/PathIterator.cc \
	common/PathManager.cc \
	common/Project.cc \
	common/Token.cc \
	common/TokenStream.cc \
	common/Unit.cc \
	common/MacroUnit.cc \
	common/UnitIterator.cc \
	common/UnitManager.cc \
	manip/CMatch.cc \
	manip/CMatchChecker.cc \
	manip/CSubMatch.cc \
	manip/CTreeMatcher.cc \
	manip/ManipCommander.cc \
	manip/ManipController.cc \
	manip/Manipulators.cc \
	manip/MatchCollector.cc \
	manip/RuleTable.cc \
	scanner/KeywordRecognizer.cc \
	scanner/CCommentRecognizer.cc \
	scanner/CRecognizer.cc \
	scanner/CScanner.cc \
	scanner/OrangeRecognizer.cc \
	scanner/CScanBuffer.cc \
	scanner/SB_Sequential.cc \
	basics/DString.cc \
	basics/Heap.cc \
	basics/KeyboardSource.cc \
	basics/List.cc \
	basics/MemPool.cc \
	basics/Pipe.cc \
	basics/PipedCmd.cc \
	basics/RegComp.cc \
	basics/SmartPtr.cc \
	basics/StrCol.cc \
	basics/StrHashTable.cc \
	basics/SysCall.cc \
	basics/TerminalSink.cc \
	basics/VerboseMgr.cc \
	basics/VoidPtrArray.cc \
	basics/WChar.cc \
	basics/GPLHeader.cc \
	parser/acparser/ACTree.cc \
	parser/acparser/ACIntroAnalyzer.cc \
	parser/ccparser/CCAssocScopes.cc \
	parser/ccparser/CCBuilder.cc \
	parser/ccparser/CCConvSeq.cc \
	parser/ccparser/CCConversion.cc \
	parser/ccparser/CCConversions.cc \
	parser/ccparser/CCInstantiation.cc \
	parser/ccparser/CCNameLookup.cc \
	parser/ccparser/CCOverloading.cc \
	parser/ccparser/CCSemExpr.cc \
	parser/ccparser/CCSemVisitor.cc \
	parser/ccparser/CCSemantic.cc \
	parser/ccparser/CCSyntax.cc \
	parser/ccparser/DeducedArgument.cc \
	parser/ccparser/InstantiationCandidate.cc \
	parser/cparser/CBuilder.cc \
	parser/cparser/CTree.cc \
	parser/cparser/CSemExpr.cc \
	parser/cparser/CSemDeclarator.cc \
	parser/cparser/CSyntax.cc \
	parser/cparser/CSemantic.cc \
	parser/cparser/CSemVisitor.cc \
	parser/cparser/CSemDeclSpecs.cc \
	parser/cparser/CProject.cc \
	parser/cparser/CPrintVisitor.cc \
	parser/cparser/CTranslationUnit.cc \
	parser/cparser/CUnit.cc \
	parser/Syntax.cc \
	parser/Builder.cc \
	parser/CConstant.cc \
	parser/CVisitor.cc \
	parser/Parser.cc \
	parser/Semantic.cc \
	parser/Tracing.cc \
	infos/CArgumentInfo.cc \
	infos/CAttributeInfo.cc \
	infos/CBaseClassInfo.cc \
	infos/CClassDatabase.cc \
	infos/CClassInfo.cc \
	infos/CEnumInfo.cc \
	infos/CEnumeratorInfo.cc \
	infos/CFunctionInfo.cc \
	infos/CLabelInfo.cc \
	infos/CLocalScope.cc \
	infos/CMemberAliasInfo.cc \
	infos/CNamespaceInfo.cc \
	infos/CObjectInfo.cc \
	infos/CRecord.cc \
	infos/CScopeInfo.cc \
	infos/CSourceInfo.cc \
	infos/CStructure.cc \
	infos/CTemplateInfo.cc \
	infos/CTemplateParamInfo.cc \
	infos/CTypeInfo.cc \
	infos/CTypedefInfo.cc \
	infos/CUnionInfo.cc \
	infos/CUsingInfo.cc \
	infos/Filter.cc \
	infos/Signature.cc \
	infos/acinfos/ACAdviceInfo.cc \
	infos/acinfos/ACAspectInfo.cc \
	infos/acinfos/ACSliceInfo.cc \
	infos/acinfos/ACClassDatabase.cc

DONTWEAVE := \
	aspects/ExtACTree.cc \
	cpp/ImportHandler.cc \
	cpp/PreAnswer.cc \
	cpp/PreAssertionEvaluator.cc \
	cpp/PreMacro.cc \
	cpp/PreMacroExpander.cc \
	cpp/PreMacroManager.cc \
	cpp/PreParserState.cc \
	cpp/PrePredicate.cc \
	cpp/PrePredicateManager.cc \
	cpp/PrePrintVisitor.cc \
	cpp/PreTree.cc \
	cpp/PreTreeComposite.cc \
	common/OptsParser.cc \
	common/Config.cc \
	common/SimpleParser.cc \
	common/ErrorCollector.cc \
	common/ErrorSeverity.cc \
	common/ErrorSink.cc \
	common/ErrorStream.cc \
	common/FileUnit.cc \
	common/Filename.cc \
	common/FilenameInfo.cc \
	common/LocManager.cc \
	common/Location.cc \
	common/LocationInfo.cc \
	common/PathInfo.cc \
	common/PathIterator.cc \
	common/PathManager.cc \
	common/Project.cc \
	common/Token.cc \
	common/TokenStream.cc \
	common/Unit.cc \
	common/MacroUnit.cc \
	common/UnitIterator.cc \
	common/UnitManager.cc \
	manip/CMatch.cc \
	manip/CMatchChecker.cc \
	manip/CSubMatch.cc \
	manip/CTreeMatcher.cc \
	manip/ManipCommander.cc \
	manip/ManipController.cc \
	manip/Manipulators.cc \
	manip/MatchCollector.cc \
	manip/RuleTable.cc \
	scanner/KeywordRecognizer.cc \
	scanner/CCommentRecognizer.cc \
	scanner/CRecognizer.cc \
	scanner/OrangeRecognizer.cc \
	scanner/CScanBuffer.cc \
	scanner/SB_Sequential.cc \
	basics/DString.cc \
	basics/Heap.cc \
	basics/KeyboardSource.cc \
	basics/List.cc \
	basics/MemPool.cc \
	basics/Pipe.cc \
	basics/PipedCmd.cc \
	basics/RegComp.cc \
	basics/SmartPtr.cc \
	basics/StrCol.cc \
	basics/StrHashTable.cc \
	basics/SysCall.cc \
	basics/TerminalSink.cc \
	basics/VerboseMgr.cc \
	basics/VoidPtrArray.cc \
	basics/WChar.cc \
	basics/GPLHeader.cc \
	parser/acparser/ACIntroAnalyzer.cc \
	parser/ccparser/CCAssocScopes.cc \
	parser/ccparser/CCConvSeq.cc \
	parser/ccparser/CCConversion.cc \
	parser/ccparser/CCConversions.cc \
	parser/ccparser/CCInstantiation.cc \
	parser/ccparser/CCOverloading.cc \
	parser/ccparser/CCSemVisitor.cc \
	parser/ccparser/DeducedArgument.cc \
	parser/ccparser/InstantiationCandidate.cc \
	parser/cparser/CSemDeclarator.cc \
	parser/cparser/CSemVisitor.cc \
	parser/cparser/CPrintVisitor.cc \
	parser/cparser/CTranslationUnit.cc \
	parser/cparser/CUnit.cc \
	parser/Builder.cc \
	parser/CConstant.cc \
	parser/CVisitor.cc \
	parser/Semantic.cc \
	parser/Tracing.cc \
	infos/CArgumentInfo.cc \
	infos/CAttributeInfo.cc \
	infos/CBaseClassInfo.cc \
	infos/CClassInfo.cc \
	infos/CEnumInfo.cc \
	infos/CEnumeratorInfo.cc \
	infos/CFunctionInfo.cc \
	infos/CLabelInfo.cc \
	infos/CLocalScope.cc \
	infos/CMemberAliasInfo.cc \
	infos/CNamespaceInfo.cc \
	infos/CObjectInfo.cc \
	infos/CRecord.cc \
	infos/CScopeInfo.cc \
	infos/CSourceInfo.cc \
	infos/CStructure.cc \
	infos/CTemplateInfo.cc \
	infos/CTemplateParamInfo.cc \
	infos/CTypeInfo.cc \
	infos/CTypedefInfo.cc \
	infos/CUnionInfo.cc \
	infos/CUsingInfo.cc \
	infos/Filter.cc \
	infos/Signature.cc \
	infos/acinfos/ACAdviceInfo.cc \
	infos/acinfos/ACAspectInfo.cc \
	infos/acinfos/ACSliceInfo.cc \
	infos/acinfos/ACClassDatabase.cc

LINKONCE := \
	puma_linkonce.cc
