// This file is part of PUMA.
// Copyright (C) 1999-2003  The PUMA developer team.
//                                                                
// This program is free software;  you can redistribute it and/or 
// modify it under the terms of the GNU General Public License as 
// published by the Free Software Foundation; either version 2 of 
// the License, or (at your option) any later version.            
//                                                                
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
// GNU General Public License for more details.                   
//                                                                
// You should have received a copy of the GNU General Public      
// License along with this program; if not, write to the Free     
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
// MA  02111-1307  USA                                            

#ifndef __Filter_h__
#define __Filter_h__

#include "Puma/Signature.h"
#include "Puma/RegComp.h"
#include "Puma/Array.h"

namespace Puma {


class Filter : public Signature {
  RegComp *re_name;
  RegComp *re_type;
  Array<RegComp*> re_arg;
  bool compiled;
   
  RegComp *new_re (const char *);
  void clear ();
  void compile ();

public:
  Filter (const char *);
  ~Filter ();
   
  bool match (Signature &);
};


} // namespace Puma

#endif /* __Filter_h__ */
