#ifndef __ac_FIRST__tmp_AOP_LIN_AOP_Puma_gen45release_step1__
#define __ac_FIRST__tmp_AOP_LIN_AOP_Puma_gen45release_step1__
#define __ac_FIRST_FILE__tmp_AOP_LIN_AOP_Puma_gen45release_step1_inc_Puma_CStructure_h__

#ifndef __ac_h_
#define __ac_h_
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 0x0004, EXECUTION = 0x0008, CONSTRUCTION = 0x0010, DESTRUCTION = 0x0020 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    char _data[sizeof (T)];
    ~ResultBuffer () { ((T*)_data)->T::~T(); }
    operator T& () const { return *(T*)_data; }
  };
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (__SIZE_TYPE__, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __ac_h_
#endif // __ac_FIRST__tmp_AOP_LIN_AOP_Puma_gen45release_step1__
// This file is part of PUMA.
// Copyright (C) 1999-2003  The PUMA developer team.
//                                                                
// This program is free software;  you can redistribute it and/or 
// modify it under the terms of the GNU General Public License as 
// published by the Free Software Foundation; either version 2 of 
// the License, or (at your option) any later version.            
//                                                                
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
// GNU General Public License for more details.                   
//                                                                
// You should have received a copy of the GNU General Public      
// License along with this program; if not, write to the Free     
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
// MA  02111-1307  USA                                            

#ifndef __CStructure_h__
#define __CStructure_h__

// base class of everything that also is a scope
// (function, class, union, namespace...)
// stores semantic info objects for variables, 
// enumerators, function and template parameters,
// typedefs, classes, unions, enumerations, 
// namespaces, using-directives, friend function 
// declarations, functions, class methods, class 
// data members, function and class templates,
// function and class template instances, member 
// aliases

#include "Puma/CScopeInfo.h"
#include "Puma/Array.h"

#ifndef __puma

#include <map>
#include <set>
#include <list>
#include <string>
#include "Puma/DString.h"
using namespace std;

#endif

namespace Puma {


class CAttributeInfo;
class CTemplateParamInfo;
class CFunctionInfo;
class CClassInfo;
class CUnionInfo;
class CEnumInfo;
class CTypedefInfo;
class CNamespaceInfo;
class CUsingInfo;
class CMemberAliasInfo;

} // closed Puma
class WinIfExists;
class WinImportHandler;
class WinMacros;
class CMatchSyntax;
class ExtGnu;
class ExtAC;
class ExtACBuilderCoupling;
class ExtACSyntaxCoupling;
class ExtACTree;
class ExtACKeywords;
class WinAsm;
class WinDeclSpecs;
class WinMemberExplSpec;
class WinTypeKeywords;
class PragmaOnceUnitState;
class PragmaOnce;
class CCExprResolve;
class CExprResolve;
namespace Puma {
class CStructure : public CScopeInfo {  friend class ::WinIfExists;
  friend class ::WinImportHandler;
  friend class ::WinMacros;
  friend class ::CMatchSyntax;
  friend class ::ExtGnu;
  friend class ::ExtAC;
  friend class ::ExtACBuilderCoupling;
  friend class ::ExtACSyntaxCoupling;
  friend class ::ExtACTree;
  friend class ::ExtACKeywords;
  friend class ::WinAsm;
  friend class ::WinDeclSpecs;
  friend class ::WinMemberExplSpec;
  friend class ::WinTypeKeywords;
  friend class ::PragmaOnceUnitState;
  friend class ::PragmaOnce;
  friend class ::CCExprResolve;
  friend class ::CExprResolve;

public:
#ifndef __puma
  typedef list<CObjectInfo*> ObjectInfoList;
  typedef map<DString,ObjectInfoList> ObjectsByName;
  typedef set<CObjectInfo*> ObjectInfoSet;
#endif 

private:
  CStructure                *_Shared;
  Array<CObjectInfo*>        _Objects; // ALL objects (mixed, in the order added to)
  Array<CAttributeInfo*>     _Attributes;
  Array<CTemplateParamInfo*> _TemplateParams;
  Array<CFunctionInfo*>      _Functions;
  Array<CObjectInfo*>        _Types;
  Array<CUsingInfo*>         _Usings;     
  Array<CRecord*>            _Friends;
  Array<CNamespaceInfo*>     _Namespaces;     
  Array<CMemberAliasInfo*>   _Aliases;     
#ifndef __puma
  ObjectsByName              _ObjectMap;
  ObjectInfoSet              _ObjectSet;
#endif

protected:
  CStructure (ObjectId);

public:
  ~CStructure ();

  // Get ... 
#ifndef __puma
  ObjectsByName& ObjectInfoMap() { return _Shared->_ObjectMap; }
  const ObjectInfoSet& ObjectInfos() const { return _Shared->_ObjectSet; }
#endif 
  unsigned Objects () const;                        // all entities in scope
  unsigned Objects (const DString&) const;
  unsigned Types () const;                          // type declarations
  unsigned Types (const DString&) const;
  unsigned Attributes () const;                     // data objects
  unsigned Attributes (const DString&) const;
  unsigned TemplateParams () const;                 // template parameters
  unsigned TemplateParams (const DString&) const;
  unsigned Functions () const;                      // functions, methods, function
  unsigned Functions (const DString&) const;        // templates and its instances
  unsigned Usings () const;                         // using-directives
  unsigned Usings (const DString&) const;
  unsigned Namespaces () const;                     // namespaces
  unsigned Namespaces (const DString&) const;
  unsigned Friends () const;                        // friend function declarations
  unsigned Friends (const DString&) const;
  CObjectInfo *Object (unsigned) const;
  CObjectInfo *Object (const DString&, unsigned = 0) const;
  CObjectInfo *Type (unsigned) const;
  CObjectInfo *Type (const DString&, unsigned = 0) const;
  CUsingInfo *Using (unsigned) const;
  CUsingInfo *Using (const DString&, unsigned = 0) const;
  CNamespaceInfo *Namespace (unsigned) const;
  CNamespaceInfo *Namespace (const DString&, unsigned = 0) const;
  CRecord *Friend (unsigned) const;
  CRecord *Friend (const DString&, unsigned = 0) const;
  CAttributeInfo *Attribute (unsigned) const;
  CAttributeInfo *Attribute (const DString&, unsigned = 0) const;
  CTemplateParamInfo *TemplateParam (unsigned) const;
  CTemplateParamInfo *TemplateParam (const DString&, unsigned = 0) const;
  CFunctionInfo *Function (unsigned) const;
  CFunctionInfo *Function (const DString&, unsigned = 0) const;
  CFunctionInfo *Function (const DString&, CTypeInfo *) const;

  bool isMemberAlias (const CObjectInfo *) const; // is a member alias info?
  CMemberAliasInfo *MemberAlias (const CObjectInfo *) const; // get denoted member

  // Set ...
  void setShared (CStructure *);
  void addObject (CObjectInfo *);
  void addAttribute (CAttributeInfo *);
  void addTemplateParam (CTemplateParamInfo *);
  void addFunction (CFunctionInfo *);
  void addType (CObjectInfo *);
  void addUsing (CUsingInfo *);
  void addNamespace (CNamespaceInfo *);
  void addFriend (CRecord *);
  void removeObject (const CObjectInfo *);       // WILL NOT BE DESTROYED!
  void removeAttribute (const CAttributeInfo *); // WILL NOT BE DESTROYED!
  void removeTemplateParam (const CTemplateParamInfo *); // WILL NOT BE DESTROYED!
  void removeFunction (const CFunctionInfo *);   // WILL NOT BE DESTROYED!
  void removeType (const CObjectInfo *);         // WILL NOT BE DESTROYED!
  void removeUsing (const CUsingInfo *);         // WILL NOT BE DESTROYED!
  void removeNamespace (const CNamespaceInfo *); // WILL NOT BE DESTROYED!
  void removeFriend (const CRecord *);           // WILL NOT BE DESTROYED!
  void removeMemberAlias (const CMemberAliasInfo *); // WILL NOT BE DESTROYED!

  void removeRegisterEntry ();
  
  void addObjectName(CObjectInfo *); // internal use only, do not call directly
  void removeObjectName (const DString& name, CObjectInfo *info) ; // internal use only

  // Create/Delete ...
  CAttributeInfo *newAttribute ();
  CEnumInfo *newEnum ();
  CUsingInfo *newUsing ();
  CTypedefInfo *newTypedef ();
  CMemberAliasInfo *newMemberAlias (CObjectInfo *);
  void deleteAttribute (const CAttributeInfo *); 
  void deleteEnum (const CEnumInfo *);
  void deleteUsing (const CUsingInfo *);
  void deleteTypedef (const CTypedefInfo *);
  void deleteMemberAlias (const CMemberAliasInfo *);
};

#define INIT_SIZE 20
#define INCR_SIZE 20

inline CStructure::CStructure (CObjectInfo::ObjectId id) :
  CScopeInfo (id),
  _Shared (this),
  _Objects (INIT_SIZE, INCR_SIZE),
  _Attributes (INIT_SIZE, INCR_SIZE),
  _TemplateParams (INIT_SIZE, INCR_SIZE),
  _Functions (INIT_SIZE, INCR_SIZE),
  _Types (INIT_SIZE, INCR_SIZE),
  _Usings (INIT_SIZE, INCR_SIZE),
  _Friends (INIT_SIZE, INCR_SIZE),
  _Namespaces (INIT_SIZE, INCR_SIZE),
  _Aliases (INIT_SIZE, INCR_SIZE)
 {}
 
inline unsigned CStructure::Objects () const
 { return _Objects.length (); }
inline unsigned CStructure::Types () const
 { return _Types.length (); }
inline unsigned CStructure::Attributes () const
 { return _Attributes.length (); }
inline unsigned CStructure::TemplateParams () const
 { return _TemplateParams.length (); }
inline unsigned CStructure::Functions () const
 { return _Functions.length (); }
inline unsigned CStructure::Usings () const
 { return _Usings.length (); }
inline unsigned CStructure::Namespaces () const
 { return _Namespaces.length (); }
inline unsigned CStructure::Friends () const
 { return _Friends.length (); }
inline CObjectInfo *CStructure::Object (unsigned n) const
 { return _Objects.lookup (n); }
inline CObjectInfo *CStructure::Type (unsigned n) const
 { return _Types.lookup (n); }
inline CAttributeInfo *CStructure::Attribute (unsigned n) const
 { return _Attributes.lookup (n); }
inline CTemplateParamInfo *CStructure::TemplateParam (unsigned n) const
 { return _TemplateParams.lookup (n); }
inline CFunctionInfo *CStructure::Function (unsigned n) const
 { return _Functions.lookup (n); }
inline CUsingInfo *CStructure::Using (unsigned n) const
 { return _Usings.lookup (n); }
inline CNamespaceInfo *CStructure::Namespace (unsigned n) const
 { return _Namespaces.lookup (n); }
inline CRecord *CStructure::Friend (unsigned n) const
 { return _Friends.lookup (n); }

inline bool CStructure::isMemberAlias (const CObjectInfo *info) const
 { return (MemberAlias (info)); }
 

} // namespace Puma

#endif /* __CStructure_h__ */

#ifdef __ac_FIRST_FILE__tmp_AOP_LIN_AOP_Puma_gen45release_step1_inc_Puma_CStructure_h__
/*** begin of aspect includes ***/
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinIfExists_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinIfExists_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinIfExists_ah__
#include "WinIfExists.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinImportHandler_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinImportHandler_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinImportHandler_ah__
#include "WinImportHandler.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMacros_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMacros_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMacros_ah__
#include "WinMacros.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CMatchSyntax_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CMatchSyntax_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CMatchSyntax_ah__
#include "CMatchSyntax.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtGnu_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtGnu_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtAC_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtAC_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtAC_ah__
#include "ExtAC.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#include "ExtACBuilderH.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__
#include "ExtACBuilderCC.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__
#include "ExtACSyntaxH.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__
#include "ExtACSyntaxCC.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACTree_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACTree_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACKeywords_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACKeywords_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#include "ExtACKeywords.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_TraceSyntax_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_TraceSyntax_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_TraceSyntax_ah__
#include "TraceSyntax.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinAsm_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinAsm_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinAsm_ah__
#include "WinAsm.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__
#include "WinDeclSpecs.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__
#include "WinMemberExplSpec.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__
#include "WinTypeKeywords.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnce_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnce_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnce_ah__
#include "PragmaOnce.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveH_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveH_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveH_ah__
#include "CCExprResolveH.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__
#include "CCExprResolveCC.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveH_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveH_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveH_ah__
#include "CExprResolveH.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveCC_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveCC_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveCC_ah__
#include "CExprResolveCC.ah"
#endif
/*** end of aspect includes ***/
#undef __ac_FIRST__tmp_AOP_LIN_AOP_Puma_gen45release_step1__
#undef __ac_FIRST_FILE__tmp_AOP_LIN_AOP_Puma_gen45release_step1_inc_Puma_CStructure_h__
#endif // __ac_FIRST_FILE__tmp_AOP_LIN_AOP_Puma_gen45release_step1_inc_Puma_CStructure_h__
