#ifndef __ac_FIRST__tmp_AOP_LIN_AOP_Puma_gen45release_step1__
#define __ac_FIRST__tmp_AOP_LIN_AOP_Puma_gen45release_step1__
#define __ac_FIRST_FILE__tmp_AOP_LIN_AOP_Puma_gen45release_step1_inc_Puma_CCSemExpr_h__

#ifndef __ac_h_
#define __ac_h_
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 0x0004, EXECUTION = 0x0008, CONSTRUCTION = 0x0010, DESTRUCTION = 0x0020 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    char _data[sizeof (T)];
    ~ResultBuffer () { ((T*)_data)->T::~T(); }
    operator T& () const { return *(T*)_data; }
  };
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (__SIZE_TYPE__, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __ac_h_
#endif // __ac_FIRST__tmp_AOP_LIN_AOP_Puma_gen45release_step1__
#include "ExtGnu.ah"
#ifndef __ac_guard__tmp_AOP_LIN_AOP_Puma_gen45release_step1_inc_Puma_CCSemExpr_h__
#define __ac_guard__tmp_AOP_LIN_AOP_Puma_gen45release_step1_inc_Puma_CCSemExpr_h__
// This file is part of PUMA.
// Copyright (C) 1999-2003  The PUMA developer team.
//                                                                
// This program is free software;  you can redistribute it and/or 
// modify it under the terms of the GNU General Public License as 
// published by the Free Software Foundation; either version 2 of 
// the License, or (at your option) any later version.            
//                                                                
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
// GNU General Public License for more details.                   
//                                                                
// You should have received a copy of the GNU General Public      
// License along with this program; if not, write to the Free     
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
// MA  02111-1307  USA                                            

#ifndef __CCSemExpr_h__
#define __CCSemExpr_h__

#include "Puma/ErrorSink.h"
#include "Puma/Limits.h"
#include "Puma/Config.h"
#include "Puma/CTree.h"

namespace Puma {

class CStructure;
class CObjectInfo;
class CClassInfo;
class CTypeInfo;
class CCNameLookup;
class CCOverloading;
class CRecord;


} // closed Puma
class WinIfExists;
class WinImportHandler;
class WinMacros;
class CMatchSyntax;
class ExtGnu;
class ExtAC;
class ExtACBuilderCoupling;
class ExtACSyntaxCoupling;
class ExtACTree;
class ExtACKeywords;
class WinAsm;
class WinDeclSpecs;
class WinMemberExplSpec;
class WinTypeKeywords;
class PragmaOnceUnitState;
class PragmaOnce;
class CCExprResolve;
class CExprResolve;
namespace Puma {
class CCSemExpr {  friend class ::WinIfExists;
  friend class ::WinImportHandler;
  friend class ::WinMacros;
  friend class ::CMatchSyntax;
  friend class ::ExtGnu;
  friend class ::ExtAC;
  friend class ::ExtACBuilderCoupling;
  friend class ::ExtACSyntaxCoupling;
  friend class ::ExtACTree;
  friend class ::ExtACKeywords;
  friend class ::WinAsm;
  friend class ::WinDeclSpecs;
  friend class ::WinMemberExplSpec;
  friend class ::WinTypeKeywords;
  friend class ::PragmaOnceUnitState;
  friend class ::PragmaOnce;
  friend class ::CCExprResolve;
  friend class ::CExprResolve;

protected:
  ErrorSink &err;            // error stream
  CStructure *current_scope;
  CT_CallExpr *fct_call;     // when evaluating first operand of function call
  bool dependent_args;      
  bool dependent;            // expression dependent on template parameter

public: // public interface
  CCSemExpr (ErrorSink &, CStructure *scope);

  CTypeInfo *resolveExpr (CTree *expr, CTree *base = (CTree*)0);
  CTypeInfo *resolveInit (CTree *node, CTree *base);

  void configure (Config &) {}
  
public: // basic expression operations
  static bool isLvalue (CTree *);
  static bool isRvalue (CTree *);
  static bool isModifiable (CTypeInfo *, unsigned long = 0);

  // constant expressions
  static bool isConstIntExpr (CTree *);
  // not yet implemented! always returns true!
  static bool isConstExpr (CTree *); 

  // type conversions
  static CTypeInfo *usualArithmeticConv (CTree *, CTree *, CTree *);
  static CTypeInfo *convLvalueToRvalue (CTree *, CTree *, CTree * = (CTree*)0);
  static CTypeInfo *castToType (CTypeInfo *, CTree *, CTree *, bool = true);
  static CTypeInfo *intPromotion (CTree *, CTree *);

  static CObjectInfo *findObject (CTree *);
  static bool sameOrBaseClass (CRecord *, CRecord *);
  static bool baseClass (CClassInfo *, CClassInfo *);

  // return true if evaluated expression
  // depend on template parameter
  bool isDependent () const;
  // (for a given expression)
  static bool isDependent (CTree *);

  // expression evaluation
  CTypeInfo *resolve (CTree *, CTree *);
  CTypeInfo *resolve (CT_Expression *, CTree *);
  CTypeInfo *resolve (CT_CallExpr *, CTree *);
  CTypeInfo *resolve (CT_MembPtrExpr *, CTree *);
  CTypeInfo *resolve (CT_SimpleName *, CTree *);
  CTypeInfo *resolve (CT_BinaryExpr *, CTree *);
  CTypeInfo *resolve (CT_UnaryExpr *, CTree *);
  CTypeInfo *resolve (CT_PostfixExpr *, CTree *);
  CTypeInfo *resolve (CT_ConstructExpr *, CTree *);
  CTypeInfo *resolve (CT_CmpdLiteral *, CTree *);
  CTypeInfo *resolve (CT_NewExpr *, CTree *);
  CTypeInfo *resolve (CT_DeleteExpr *, CTree *);
  CTypeInfo *resolve (CT_IfThenExpr *, CTree *);
  CTypeInfo *resolve (CT_DerefExpr *, CTree *);
  CTypeInfo *resolve (CT_AddrExpr *, CTree *);
  CTypeInfo *resolve (CT_CastExpr *, CTree *);
  CTypeInfo *resolve (CT_DynamicCast *, CTree *);
  CTypeInfo *resolve (CT_StaticCast *, CTree *);
  CTypeInfo *resolve (CT_ReintCast *, CTree *);
  CTypeInfo *resolve (CT_ConstCast *, CTree *);
  CTypeInfo *resolve (CT_TypeidExpr *, CTree *);
  CTypeInfo *resolve (CT_ThrowExpr *, CTree *);
  CTypeInfo *resolve (CT_SizeofExpr *, CTree *);
  CTypeInfo *resolve (CT_IndexExpr *, CTree *);
  CTypeInfo *resolve (CT_BracedExpr *, CTree *);
  CTypeInfo *resolve (CT_Bool *, CTree *);
  CTypeInfo *resolve (CT_Character *, CTree *);
  CTypeInfo *resolve (CT_WideCharacter *, CTree *);
  CTypeInfo *resolve (CT_String *, CTree *);
  CTypeInfo *resolve (CT_WideString *, CTree *);
  CTypeInfo *resolve (CT_Integer *, CTree *);
  CTypeInfo *resolve (CT_Float *, CTree *);

protected:
  // binary expressions
  CTypeInfo *binary_ass (CT_BinaryExpr *, CTree *);
  CTypeInfo *binary_comma (CT_BinaryExpr *, CTree *);
  CTypeInfo *binary_log (CT_BinaryExpr *, CTree *);
  CTypeInfo *binary_bit (CT_BinaryExpr *, CTree *);
  CTypeInfo *binary_equ (CT_BinaryExpr *, CTree *);
  CTypeInfo *binary_rel (CT_BinaryExpr *, CTree *);
  CTypeInfo *binary_shift (CT_BinaryExpr *, CTree *);
  CTypeInfo *binary_add (CT_BinaryExpr *, CTree *);
  CTypeInfo *binary_mul (CT_BinaryExpr *, CTree *);
  CTypeInfo *binary_ptm (CT_BinaryExpr *, CTree *);
  void apply_binary_op (CTree *, int);

  // operator overloading
  CTypeInfo *overloadedOperator (CTree *, CTree *, const char *, int, 
                                 CTree *, CTree * = 0);

  // constant expressions
  static bool isConstIntegralExpr (CTree *);

  // literal evaluation
  void overflow (CTree *, int, bool &) const;
  int scanCharacter (CTree *, LONG_LONG &) const;
  LONG_LONG nextCharacter (const char *&) const;

  // helper
  bool depBaseClass () const;
  CTree *baseTree (CTree *) const;
  bool isDependent (CTree *, bool);
  bool resetDependent ();
  bool isClassOrEnum (CTypeInfo *) const;
  bool sameUnqualBaseType (CTypeInfo *, CTypeInfo *) const;
  bool checkDeclsFound (CTree *, CCNameLookup &) const;
  void passOnConstant (CTree *, CTree *, CTypeInfo *) const;
  bool validOvlFctSet (CTree *, const char *, const char *, CCOverloading &);
   private:
  typedef CCSemExpr ExtGnuStmtExprsCCSemExpr;
 public :
CTypeInfo * resolve ( CT_GnuStatementExpr * , CTree * ) ;};

inline CCSemExpr::CCSemExpr (ErrorSink &e, CStructure *s) : 
  err (e), 
  current_scope (s), 
  fct_call (0), 
  dependent_args (false),
  dependent (false)
 {}

inline bool CCSemExpr::isDependent () const
 { return dependent; }


} // namespace Puma

#endif /* __CCSemExpr_h__ */
#endif // __ac_guard__tmp_AOP_LIN_AOP_Puma_gen45release_step1_inc_Puma_CCSemExpr_h__

#ifdef __ac_FIRST_FILE__tmp_AOP_LIN_AOP_Puma_gen45release_step1_inc_Puma_CCSemExpr_h__
/*** begin of aspect includes ***/
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinIfExists_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinIfExists_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinIfExists_ah__
#include "WinIfExists.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinImportHandler_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinImportHandler_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinImportHandler_ah__
#include "WinImportHandler.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMacros_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMacros_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMacros_ah__
#include "WinMacros.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CMatchSyntax_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CMatchSyntax_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CMatchSyntax_ah__
#include "CMatchSyntax.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtGnu_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtGnu_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtAC_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtAC_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtAC_ah__
#include "ExtAC.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#include "ExtACBuilderH.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__
#include "ExtACBuilderCC.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__
#include "ExtACSyntaxH.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__
#include "ExtACSyntaxCC.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACTree_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACTree_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACKeywords_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACKeywords_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#include "ExtACKeywords.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_TraceSyntax_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_TraceSyntax_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_TraceSyntax_ah__
#include "TraceSyntax.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinAsm_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinAsm_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinAsm_ah__
#include "WinAsm.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__
#include "WinDeclSpecs.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__
#include "WinMemberExplSpec.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__
#include "WinTypeKeywords.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnce_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnce_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_PragmaOnce_ah__
#include "PragmaOnce.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveH_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveH_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveH_ah__
#include "CCExprResolveH.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__
#include "CCExprResolveCC.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveH_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveH_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveH_ah__
#include "CExprResolveH.ah"
#endif
#if !defined(__ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveCC_ah__) && defined(__ac_need__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveCC_ah__)
#define __ac_have__tmp_AOP_LIN_AOP_Puma_gen45release_step1_aspects_CExprResolveCC_ah__
#include "CExprResolveCC.ah"
#endif
/*** end of aspect includes ***/
#undef __ac_FIRST__tmp_AOP_LIN_AOP_Puma_gen45release_step1__
#undef __ac_FIRST_FILE__tmp_AOP_LIN_AOP_Puma_gen45release_step1_inc_Puma_CCSemExpr_h__
#endif // __ac_FIRST_FILE__tmp_AOP_LIN_AOP_Puma_gen45release_step1_inc_Puma_CCSemExpr_h__
