// This file is part of PUMA.
// Copyright (C) 1999-2003  The PUMA developer team.
//                                                                
// This program is free software;  you can redistribute it and/or 
// modify it under the terms of the GNU General Public License as 
// published by the Free Software Foundation; either version 2 of 
// the License, or (at your option) any later version.            
//                                                                
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
// GNU General Public License for more details.                   
//                                                                
// You should have received a copy of the GNU General Public      
// License along with this program; if not, write to the Free     
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
// MA  02111-1307  USA                                            

#ifndef __CUsingInfo_h__
#define __CUsingInfo_h__

// using-directive info
// knows the namespace info to which the 
// using-directive refers

#include "Puma/CScopeRequest.h"

namespace Puma {


class CNamespaceInfo;

class CUsingInfo : public CScopeRequest {
  CNamespaceInfo *_Namespace;

public:
  CUsingInfo ();
  ~CUsingInfo ();

  CNamespaceInfo *Namespace () const;        // the denoted namespace
  void Namespace (CNamespaceInfo *);
};

inline CUsingInfo::CUsingInfo () :
  CScopeRequest (CObjectInfo::USING_INFO),
  _Namespace (0)
 {}
 
inline CNamespaceInfo *CUsingInfo::Namespace () const 
 { return _Namespace; }
inline void CUsingInfo::Namespace (CNamespaceInfo *nsinfo)
 { _Namespace = nsinfo; }


} // namespace Puma

#endif /* __CUsingInfo_h__ */
